#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <wchar.h>
#include <complex.h>
#include <math.h>

// агрегаты данных: массивы, структуры, представление массивов указателями...

//-----------------------------------------------------

void test10( void ) {     // стандартный массив
   int ai[] = { 1, 2, 3, 4, 5 }, ni, j;
   printf( "%d элементов массива : ", ni = sizeof( ai ) / sizeof( ai[ 0 ] ) );
   for( j = 0; j < ni; j++ ) 
      printf( "%d%s", ai[ j ], j != ni - 1 ? ", " : "\n" );
}

//---------------------------------------------------------

void test11( void ) {
   struct line {
      struct point {
         int x, y;
      } end[ 2 ];
      int color;
   };
   struct line l1 = { { { 3, 3 }, { 17, 17 } }, 5 },
               *p1 = &l1;
   printf( "различные нотации для элемента массива:\n" );
   printf( "[%d,%d] , ", p1->end[ 0 ].x, p1->end[ 1 ].x );
   printf( "[%d,%d] , ", (*p1).end[ 0 ].x, (*p1).end[ 1 ].x );
   printf( "[%d,%d] , ", (*p1).end->x, ( p1->end + 1 )->x );
   printf( "\n" );
   struct line curve[] = {
      { { { 0, 0 }, { 2, 3 }   }, 5 },
      { { { 2, 3 }, { 5, 7 }   }, 5 },
      { { { 5, 7 }, { 11, 13 } }, 5 },
   };
   printf( "%d -> %d -> %d\n",
           curve[ 0 ].end[ 0 ].x,
           ( ( curve + 1 )->end + 1 )->x,
           ( *( ( *( curve + 2 ) ).end + 1 ) ).y );
}

//-----------------------------------------------------

void test12( void ) {
   int a2[ 3 ][ 2 ] = { { 1, 2 }, { 3, 4 }, { 5, 6 } },
       b2[ 3 ][ 2 ] = { 1, 2, 3, 4, 5, 6 },    // вызовет warning
       i1, i2;
   printf( "инициализация многомерного массива:\n" );
   for( i1 = 0; i1 < sizeof( a2 ) / sizeof( *a2 ) ; i1++ )
      for( i2 = 0; i2 < sizeof( *a2 ) / sizeof( **a2 ); i2++ )
         printf( "%d , ", a2[ i1 ][ i2 ] );
   printf( "\n" );
   for( i1 = 0; i1 < sizeof( b2 ) / sizeof( *b2 ) ; i1++ )
      for( i2 = 0; i2 < sizeof( *b2 ) / sizeof( **b2 ); i2++ )
         printf( "%d , ", b2[ i1 ][ i2 ] );
   printf( "\n" );
}

//---------------------------------------------------------

void test13( void ) {     // неполная инициализация массива
   int ai[ 10 ] = { 1, 2, 3, 4, 5 }, i, j;
   printf( "неполная инициализация массива:\n" );
   printf( "%d элементов массива : ", i = sizeof( ai ) / sizeof( ai[ 0 ] ) );
   for( j = 0; j < i; j++ ) 
      printf( "%d%s", ai[ j ], j != i - 1 ? ", " : "\n" );
   int bi[ 3 ][ 3 ] = { { 1 }, { 2 }, { 3 } };
   for( i = 0; i < sizeof( bi ) / sizeof( bi[ 0 ] ); i++ ) {
      printf( "|" );
      for( j = 0; j < sizeof( bi[ i ] ) / sizeof( bi[ i ][ 0 ] ); j++ )
         printf( "%3d", bi[ i ][ j ] );
      printf( "  |\n" );
   }
}

//---------------------------------------------------------

typedef struct vararr {
   int n, data[ 0 ];
} vararr_t;

void varfunc( vararr_t *a ) {
   int ni = a->n, j;
   printf( "%p->[1:%d] элементы массива => ", a, ni );
   int *va = (int*)a;
   for( j = 1; j <= ni; j++ ) 
      printf( "%d%s", va[ j ], j != ni ? ", " : "\n" );
}

void test15( void ) {
   printf( "массивы переменной длины:\n" );
   int var[] = { 3, 5, 7, 10 }, i;
   for( i = 0; i < sizeof( var ) / sizeof( *var ); i++ ) {
      int len = var[ i ], j;
      vararr_t *arr = (vararr_t*)calloc( len + 1, sizeof( int ) );
      arr->n = len;
      for( j = 0; j < len; j++ ) arr->data[ j ] = j + 1;
      varfunc( arr );
      free( arr );
   }
}

//-----------------------------------------------------

void test16( void ) {
   int var[] = { 3, 5, 7, 10 }, i;
   printf( "массивы переменной длины:\n" );
   printf( "стек вызывающей функции - %p\n", var );
   for( i = 0; i < sizeof( var ) / sizeof( *var ); i++ ) {
      int len = var[ i ], j;
      vararr_t *arr = (vararr_t*)alloca( ( len + 1 ) * sizeof( int ) );
      arr->n = len;
      for( j = 0; j < len; j++ ) arr->data[ j ] = j + 1;
      varfunc( arr );
   }
}

//-----------------------------------------------------

void test17( void ) {
   int var[] = { 3, 5, 7, 10 }, n = sizeof( var ) / sizeof( *var ),
       m = 0, i, *arr;
   printf( "динамический массив изменяющейся длины:\n" );
   if( !( arr = calloc( n, sizeof( int ) ) ) ) {
      printf( "ошибка размещения: %m\n" );
      return;
   };
   for( i = 0; i < n; i++ ) arr[ i ] = var[ i ];
   while( ++m < 4 ) {
      printf( "[%02d] : ", n );
      for( i = 0; i < n; i++ ) 
         printf( "%3d%s", arr[ i ], i != n - 1 ? "," : "\n" );
      if( !realloc( arr, 2 * n * sizeof( int ) ) ) {
         printf( "ошибка переразмещения: %m\n" );
         return;
      };
      for( i = n; i < 2 * n; i++ ) arr[ i ] = -m;
      n *= 2;
   }
   free( arr );
}

//-----------------------------------------------------

void test02( void ) {     // разница в представлении масива и строки
   int ni, j;
   char ac[] = { '1', '2', '3', '4', '5', 0, '6', '\0' };
   printf( "%d элементов массива (но строка длины %d) => ", 
           ni = sizeof( ac ) / sizeof( ac[ 0 ] ), strlen( ac ) );
   for( j = 0; j < ni; j++ ) printf( "%d, ", ac[ j ] );
   printf( "\n" );
}

//-----------------------------------------------------

struct ss {
   int a1, a2, a3;
};

char *put_ss( struct ss *pss ) {
   static char msg[ 40 ];
   sprintf( msg, "%d %d %d", pss->a1, pss->a2, pss->a3 );
   return msg;
}

void test03( void ) {
   struct ss                        // присвоение эквивалентных структурных данных
      vss1 = { 1, 2, 3 }, vss2 = { 3, 2, 1 };
   printf( "присвоение больших эквивалентных структур данных:\n" );
   printf( "было { %s }", put_ss( &vss1 ) );
   vss1 = vss2;
   printf( " ... стало { %s }\n", put_ss( &vss1 ) );
}

//-----------------------------------------------------

void test04( void ) {
   typedef struct ss ss2;
   struct ss vss1 = { 1, 2, 3 };
   ss2 vss2 = { 3, 2, 1 };
   printf( "именная типизация (но не структурная):\n" );
   printf( "было { %s }", put_ss( &vss1 ) );
   *(&vss1) = *(struct ss*)&vss2;   // недопустимо без преобразования типа
   printf( " ... стало { %s }\n", put_ss( &vss1 ) );
}

//-----------------------------------------------------

void test05( void ) {
   int j;
   struct su {            // наложение разнородных данных
      union {
         char c[ 12 ];     
         short s[ 6 ];
         float f[ 3 ];
      };
   } su1 = {{{ '1', '2', '3', '4', '5', '6', 0, 0, 0, 0, 0, 0 }}};

   printf( "наложение разнородных данных:\n" );
   printf( "размер структуры %d байт\n", sizeof( su1 ) );
   printf( "как символы: " );
   for( j = 0; j < sizeof( su1.c ) / sizeof( su1.c[ 0 ] ); j++ )
      if( su1.c[ j ] != 0 ) printf( "%c, ", su1.c[ j ] );
      else printf( "\'\\0\', " );
   printf( "\nкак целые 8-бит: " );
   for( j = 0; j < sizeof( su1.c ) / sizeof( su1.c[ 0 ] ); j++ )
      printf( "%d, ", su1.c[ j ] );
   printf( "\nкак целые 16-бит: " );
   for( j = 0; j < sizeof( su1.s ) / sizeof( su1.s[ 0 ] ); j++ )
      printf( "%d, ", su1.s[ j ] );
   printf( "\nкак вещественные: " );
   for( j = 0; j < sizeof( su1.f ) / sizeof( su1.f[ 0 ] ); j++ )
      printf( "%f, ", su1.f[ j ] );
   printf( "\n" );
   char *p = (char*)&su1;
   printf( "адрес=%p : как строка %s, длиной %d символов\n",
           p, p, strlen( p ) );
}

//-----------------------------------------------------

void test06( void ) {
   struct list {             // массив структур
      char *s;
      int i;
      struct list *next;
   } a[] = {                 // кольцевой связный список
      { "abcd", 1, a + 1 },
      { "efgh", 2, a + 2 },
      { "ijkl", 3, a }
   }, *head;
   int ni = sizeof( a ) / sizeof( a[ 0 ] ), j;
   printf( "массив из %d структур => ", ni );
   for( j = 0; j < ni; j++ ) 
      printf( "%s, ", a[ j ].s );
   printf( "\nсвязный список из %d структур => ", ni );
   for( j = 0, head = a; j < ni; j++, head = head->next ) 
      printf( "%s, ", a[ j ].s );
   printf( "\nкольцевой список => " );
   for( j = 0, head = a; j < ni * 2; j++, head = head->next ) 
      printf( j != ni * 2 - 1 ? "%s, " : "%s ... ...\n", head->s );
}

//-----------------------------------------------------

char* cf( complex double c ) {
   static char s[ 30 ];
   sprintf( s, "%.2f%+.2fi", creal( c ), cimag( c ) );
   return s;
}

void test71( void ) {    // искусственное использование типа - C99
   complex double p1 = 2. + 1. * I, p2 = 1. + 2. * I;
   printf( "искусственное использование типа complex:\n" );
   printf( "координатные 2D-вычисления:\n" );
   {  printf( "%s + ", cf( p1 ) );
      printf( "%s = ", cf( p2 ) );
      printf( "%s -> length=%.2f\n", cf( p1 + p2 ), cabs( p1 + p2 ) ); }
   {  printf( "%s - ", cf( p1 ) );
      printf( "%s = ", cf( p2 ) );
      printf( "%s -> length=%.2f\n", cf( p1 - p2 ), cabs( p1 - p2 ) ); }
}

//---------------------------------------------------------

complex float sqrt_roots1( float A, float B, double C ) {
   float sq = (float)sqrt( B * B - 4. * A * C ), // решение вещественного квадратного уравнения
         r1 = ( -B + sq ) / 2. / A,
         r2 = ( -B - sq ) / 2. / A;
   return r1 + I * r2;                           // плохая численная определённость
}

complex float sqrt_roots2( float A, float B, double C ) {
   float sq = (float)sqrt( B * B - 4. * A * C ), // решение вещественного квадратного уравнения
         r1 = - ( B + ( B >= 0 ? 1. : -1. ) * sq ) / 2. / A,
         r2 = C / A / r1;
   return r1 + I * r2;                           // хорошая численная определённость
}

void test72( void ) {    // искусственное использование типа - C99
   float  b = 2.0, eps = 3.e-10;
   printf( "искусственное использование типа complex:\n" );
   printf( "квадратное уравнение: ( x - %f ) ** 2 = %e\n", b, eps );
   complex float ( *method[] )( float, float, double ) = {
      sqrt_roots1, sqrt_roots2
   };
   int i;
   for( i = 0; i < sizeof( method ) / sizeof( method[ 0 ] ); i++ ) {
      complex float r = method[ i ]( 1., ( -2. * b ), ( b * b - eps ) ); 
      double r1 = creal( r ), r2 = cimag( r ),
             c1 = ( r1 - b ) * ( r1 - b ),
             c2 = ( r2 - b ) * ( r2 - b );
      printf( "корни: %.7f и %.7f"
              " , ( x - 2 ) ** 2 -> %.5e и %.5e\n",
              r1, r2, c1, c2 );
   }
}

//---------------------------------------------------------
void ( *tests[] )( void ) = {           // последовательность тестов
        test10, test11, test12,
        test13, test15, test16,
        test17,                         // ... массивы
        test02, test03, test04,
        test05, test06,
        test71, test72,                 // искусственное использование complex
};
#include "main.c"

