#include <stdio.h>
#include <stdlib.h>

// операции и управляющие структуры :

short s1[] = { 1, 2, 3, 4, 5, 6 },
      ns = sizeof( s1 ) / sizeof( s1[ 0 ] ), i;

//-----------------------------------------------------

void test01( void ) {     // циклы
   printf( "циклы ... :\n" );
   for( i = 0; i < ns; i++ ) 
      printf( "%d, ", s1[ i ] );
   printf( "\n" );
   i = -1;
   while( ++i < ns ) {
      printf( "%d, ", s1[ i ] );
   }
   printf( "\n" );
   i = 0;
   do {
      printf( "%d, ", s1[ i ] );
   } while( i++ < ns - 1 );      // !!! - сравните с предыдущим
   printf( "\n" );
}

//-----------------------------------------------------

void test011( void ) {     // бесконечные циклы
   printf( "бесконечные циклы ... :\n" );
   i = 0;
   for( ; ; ) { 
      printf( "%d, ", s1[ i++ ] );
      if( i == ns ) break;
   }
   printf( "\n" );
   i = 0;
   while( 1 ) {
      printf( "%d, ", s1[ i++ ] );
      if( i == ns ) break;
   }
   printf( "\n" );
}

//-----------------------------------------------------

int step() {
   static int k = 0;
   int j;
   double norm = 0.;
   for( j = 0; j < 6; j++ ) norm += (double)rand() / RAND_MAX - .5;
   printf( "%f ", norm / 6 );
   return ++k < 7;
}

void test012( void ) {
   printf( "цикл без тела:\n" );
   for( ; step(); );      // цикл без тела
   printf( "\n" );
}

//-----------------------------------------------------

void test02( void ) {     // выбор
   printf( "альтернативы:\n" );
   for( i = 0; i < ns; i++ ) {
      printf( "%d : ", s1[ i ] );
      switch( s1[ i ] ) {
         case 1:
         case 2: 
            printf( "%s ", "мало" );
            break;
         case 3:
            printf( "%s ", "нормально" );
            break;
         case 4:
            printf( "%s ", "много" );
            break;
         default:
            printf( "%s ", "чрезмерно" );
         case 5:
            printf( "%s", "много " );
      }
      printf( "\n" );
   }
}

//-----------------------------------------------------

void test03( void ) {     // последовательность операторов (,)
   s1[ 5 ] = ( i = s1[ 0 ], s1[ 0 ] = s1[ 1 ], s1[ 1 ] = s1[ 2 ],
               s1[ 2 ] = s1[ 3 ], s1[ 3 ] = s1[ 4 ], s1[ 4 ] = s1[ 5 ], i );  
   printf( "последовательность операторов (,):\n" );
   for( i = 0; i < ns; i++ ) 
      printf( "%d, ", s1[ i ] );
   printf( "\n" );
}

//-----------------------------------------------------

void test04( void ) {     // вложенные блоки
   const char title[] = "теперь переменная i равна : ";
   int i = 123;
   printf( "вложенные блоки и область видимости:\n" );
   {  char *i = "строка i";
      {  double i = 0.31415e+1;
         printf( "%s%f\n", title, i );
      }
      printf( "%s%s\n", title, i );
   }
   printf( "%s%i\n", title, i );
}

//-----------------------------------------------------

void test05( void ) {     // префиксные/постфиксные одноместные операции 
   int x;
   printf( "префиксные и постфиксные операции:\n" );
   x  = -1;
   if( ++x ) printf( "%d -> истина\n", x );
   else printf( "%d -> ложь\n", x );
   x  = -1;
   if( x++ ) printf( "%d -> истина\n", x );
   else printf( "%d -> ложь\n", x );
}

//-----------------------------------------------------

#define boolean(x) ( x ? "TRUE" : "FALSE" )

void test06( void ) {     // ленивые вычисления в логических выражениях
   int x, y, w;
   printf( "ленивые вычисления в логических выражениях:\n" );
   x = y = 0;
   w = ( x++ ) || ( y++ );
   printf( "x = %d, y = %d\t<- w = %d (%s)\n", x, y, w, boolean( w ) );
   x = y = 0;
   w = ( x++ ) && ( y++ );
   printf( "x = %d, y = %d\t<- w = %d (%s)\n", x, y, w, boolean( w ) );
   x = y = -1;
   w = ( x++ ) || ( y++ );
   printf( "x = %d, y = %d\t<- w = %d (%s)\n", x, y, w, boolean( w ) );
   x = y = -1;
   w = ( x++ ) && ( y++ );
   printf( "x = %d, y = %d\t<- w = %d (%s)\n", x, y, w, boolean( w ) );
}

//-----------------------------------------------------

#define SIZE 7

typedef struct node_single {
   struct node_single *next;
   int data;  // данные узла
} node_single_t;

node_single_t *new_list( int level ) {
   struct node_single *p = malloc( sizeof( node_single_t ) );
   p->data = level;
   p->next = level ? new_list( --level ) : NULL;
   return p;
}

void put_list( node_single_t *list, int direct ) {
   if( !list ) return;
   if( direct ) printf( "%d , ", list->data );
   put_list( list->next, direct );  
   if( !direct ) printf( "%d , ", list->data );
}

void destroy( struct node_single *p ) {
   if( p->next ) destroy( p->next );
   free( p );
}

void test07( void ) {               // восходящая и нисходящая рекурсии
   struct node_single *head = new_list( SIZE );
   printf( "нисходящая рекурсия: " );
   put_list( head, 1 );
   printf( "\n" );
   printf( "восходящая рекурсия: " );
   put_list( head, 0 );
   printf( "\n" );
   destroy( head );                 // уничтожение списка
}

//-----------------------------------------------------

void ( *tests[] )( void ) = {  // последовательность тестов
        test01, test011, test012,
        test02,
        test03,
        test04,
        test05,
        test06,
        test07,
};
#include "main.c"

