#include <stdio.h>
#include <alloca.h>

// функции и вызовы:

//------------------------------------------

typedef int (*summ_t) ( int );
int summ2( int x ) { return x + 2; }
int summ3( int x ) { return x + 3; }
int summ4( int x ) { return x + 4; }
summ_t funcs[] = { summ2, summ3, summ4 };

//------------------------------------------

void test011( void ) {             // массив функций
   int i;
   printf( "массив функций:\n" ); 
   for( i = 0; i < sizeof( funcs ) / sizeof( funcs[ 0 ] ); i++ )
      printf( "%d ", funcs[ i ]( i ) );
   printf( "\n" ); 
}

//------------------------------------------

void test012( void ) {             // присвоение функций
   int i;
   summ_t summ2_2 = summ2;
   printf( "присвоение функций:\n" ); 
   printf( "%d ", summ2_2( 7 ) );
   for( i = 0; i < sizeof( funcs ) / sizeof( funcs[ 0 ] ); i++ ) {
      summ2_2 = funcs[ i ];
      printf( "%d ", summ2_2( 7 ) );
   }
   printf( "\n" );
}

//------------------------------------------

int call( summ_t func, void *data ) {
   return func( *(int*)data );
}

void set1( int x ) { x++; }
void set2( int* x ) { (*x)++; }

void test013( void ) {             // косвенный вызов
   int i = 3;
   int *pi = &i;
   printf( "косвенный вызов: %d\n", call( summ3, &i ) );
   set1( i );
   printf( "передача параметра: по значению -> %d,", i );
   set2( pi );
   printf( " по ссылке -> %d\n", i ); 
}

//------------------------------------------

#define N 10
typedef struct {
   int x[ N ];
} astruct_t;

void show_ba( astruct_t* b, astruct_t* a ) {
   int i;
   printf( "before: " );
   for( i = 0; i < N; i++ ) 
      printf( "%d%s", b->x[ i ], i != N - 1 ? ", " : ""  );
   printf( " | after: " );
   for( i = 0; i < N; i++ ) 
      printf( "%d%s", a->x[ i ], i != N - 1 ? ", " : ""  );
   printf( "\n" );
}

astruct_t revers( astruct_t s ) { // и параметр и возврат - структуры
   int n, i, j;
   n = sizeof( s ) / sizeof( int );
   for( i = 0, j = n - 1; i < j; i++, j-- ) {
      int var = s.x[ i ];
      s.x[ i ] = s.x[ j ];
      s.x[ j ] = var;
   } 
   return s;
}

void test04( void ) {        
   astruct_t before = {{ 1, 2, 3, 4, 5, 6, 7 }},
             after = {{ 10*(0) }};
   printf( "структурные параметры и возврат вызова:\n" ); 
   show_ba( &before, &after );
   printf( "revers ... ... ...\n" );
   after = revers( before );
   show_ba( &before, &after );
}

//------------------------------------------

int val1 = 123, val2 = 234;
#define PRN \
        printf( "%s : %d , %d\n", __FUNCTION__, val1, val2 )

void level2( int val1, int val2 ) {
   val1 += 11; val2 *= -1; PRN;
} 

void level1( int val1, int val2 ) {
   val1 += 7; val2 *= 3; PRN;
   level2( val1, val2 ); PRN;
} 

void test051( void ) {             // области видимости имён
   printf( "области видимости имён:\n" ); 
   PRN;
   int val1 = 22, val2 = 11;
   PRN;
   level1( val1, val2 );
   PRN;
}

//------------------------------------------

void test052( void ) {             // размещение локальных данных
   int i;
   void *pX = &pX;                 // дно кадра стека
   printf( "размещение локальных данных:\n" ); 
   printf( "дно стека = %p\n", pX ); 
   {  int X[ N ];
      for( i = 0; i < N; i++ ) X[ i ] = i + 1;
      printf( "1-й массив в блоке: %p...%p[%2d]:",
              X, &X[ N - 1 ], (void*)&X[ N - 1 ] - pX ); 
      for( i = 0; i < N; i++ ) 
         printf( "%2d%s", X[ i ], i != N - 1 ? ", " : "\n" ); 
   }  
   {  int Y[ N ];
      printf( "2-й массив в блоке: %p...%p[%2d]:",
              Y, &Y[ N - 1 ], (void*)&Y[ N - 1 ] - pX ); 
      for( i = 0; i < N; i++ ) 
         printf( "%2d%s", Y[ i ], i != N - 1 ? ", " : "\n" ); 
   }
}

//------------------------------------------

#undef N
#define N 6

void test053( void ) {             // alloca() данных в блоке
   void *X[ N ];
   int i;
   void *p = &p;                   // дно кадра стека
   printf( "alloca() в блоке:\n" ); 
   printf( "дно стека = %p\n", p ); 
   for( i = 0; i < N; i ++ ) {
      X[ i ] = alloca( sizeof( short ) );
      *(short*)X[ i ] = i + 1;
      printf( "%p[%03d]->%d%s",
              X[ i ], p - (void*)X[ i ], *(short*)X[ i ],
              ( N / 2 - 1 ) == i % ( N / 2 ) ? "\n" : " ,\t" ); 
   }
}

//------------------------------------------

void test055( void ) {             // динамические массивы (C99)
   short *X[ N ];
   int i;
   void *p = &p;                   // дно кадра стека
   printf( "VLA в блоке:\n" ); 
   printf( "дно стека = %p\n", p ); 
   for( i = 0; i < N; i ++ ) {
      short V[ i + 1 ];
      V[ 0 ] = i + 1;
      X[ i ] = &V[ 0 ];
      printf( "%p[%03d]->%d%s",
              X[ i ], p - (void*)X[ i ], *X[ i ],
              ( N / 2 - 1 ) == i % ( N / 2 ) ? "\n" : " ,\t" ); 
   }
}

//------------------------------------------

void ( *tests[] )( void ) = {       // последовательность тестов
        test011, test012, test013,  // указатели функций - операции
        test04,                     // структурные параметры, структурный возврат
        test051, test052, test053,  // локальные данные
        test055,
};
#include "main.c"

