#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <alloca.h>
#include <wchar.h>
#include <locale.h>

// символьные строки:

//----------------------------------------------------------

void test01( void ) {
   printf( "размер символа wchar_t в реализации = %d байт\n", sizeof( wchar_t ) );
}

//-----------------------------------------------------

const char buf[] = "русскоязычная строка";

void test02( void ) {
   // разница длины UTF-8 строки (русскоязычной) в байтах и символах
   printf( "UTF-8 строка: '%s', длина в байтах = %d\n", buf, strlen( buf ) );
}

//-----------------------------------------------------

void test03( void ) {
   wchar_t wbuf[ 40 ];
   printf( "преобразование UTF-8 символов в широкие (wchar_t):\n" );
   setlocale( LC_ALL, "" );   // только после этого работают преобразования!
   int n = -1, i;
   char *p;
   for( i = 0, p = (char*)buf; n != 0; i++ ) 
      p += ( n = mbtowc( wbuf + i, p, MB_CUR_MAX ) );
   printf( "преобразованная строка: '%ls'\n"
           "длина преобразованной строки = %d символов\n",
           wbuf, wcslen( wbuf ) );
}

//-----------------------------------------------------

void test11( void ) {
   int i = 0;        // начало стека локальных переменных
   char *str1 = "string1",
         str2[] = "string2",
         str3[ 40 ] = "string3";
   printf( "размещение локальных строк:\n" );
   printf( "начало стека локальных переменных: %p\n", &i );
   printf( "%d[%p] %d[%p] %d[%p]\n", 
           sizeof( str1 ), str1, sizeof( str2 ), str2, sizeof( str3 ), str3 );         
};

//----------------------------------------------------------

void test12( void ) {
   int i = 0;        // начало стека локальных переменных
   char *str1 = "pointer",
         str2[] = "array",
        *str3, *str4, *str5;
   printf( "динамическое размещение строк:\n" );
   printf( "начало стека локальных переменных: %p\n", &i );
   str3 = strdup( "strdup" );
   str4 = malloc( strlen( "malloc" ) + 1 ); strcpy( str4, "malloc" );
   str5 = alloca( strlen( "alloca" ) + 1 ); strcpy( str5, "alloca" );
   printf( "1(%s)\t=> %p\n2(%s)\t=> %p\n3(%s)\t=> %p\n"
           "4(%s)\t=> %p\n5(%s)\t=> %p\n",
           str1, str1, str2, str2, str3, str3,
           str4, str4, str5, str5 );         
   free( str3 );
   free( str4 );     // str5 не удаляется!
};

//----------------------------------------------------------

void ( *tests[] )( void ) = {  // последовательность тестов
        test01, test02, test03,
        test11, test12 //, ...
};
#include "main.c"

