#include <stdio.h>
#include <string.h>

// расширения GCC:

//----------------------------------------------------------

#define N 10
typedef struct {
   int x[ N ];
} astruct_t;

void show_ba( astruct_t* b, astruct_t* a ) {
   int i;
   printf( "before: " );
   for( i = 0; i < N; i++ )
      printf( "%d%s", b->x[ i ], i != N - 1 ? ", " : ""  );
   printf( " | after: " );
   for( i = 0; i < N; i++ )
      printf( "%d%s", a->x[ i ], i != N - 1 ? ", " : ""  );
   printf( "\n" );
}

void mod( astruct_t* s ) {  
   int n = sizeof( *s ) / sizeof( int );  
   void pow2( void ) {    // вложенное описание функции pow2
      int i;
      for( i = 0; i < n; i++ ) 
         s->x[ i ] *= s->x[ i ];
   } 
   pow2();
   return;
}

void test01( void ) {
   astruct_t before = {{ 1, 2, 3, 4, 5, 6, 7 }},
             after = before;
   mod( &after );
   printf( "вложенные описания функций (GCC):\n" );
   show_ba( &before, &after );
}

//----------------------------------------------------------

void show2( char *str1, char *str2 ) {
   char *arr = " массив ", *len = " длины"; 
   char name[ strlen( str1 ) + strlen( arr ) + 
              strlen( str2 ) + strlen( len ) + 1 ];
   strcpy( name, str1 );
   strcat( strcat( strcat( name, arr ), str2 ), len );
   printf( "%s: %d байт\n", name, sizeof( name ) );
}

void test02( void ) {
   show2( "показать", "переменной" );
};

//----------------------------------------------------------

void ( *tests[] )( void ) = {  // последовательность тестов
      test01, // вложенные определения функций
      test02, // массивы переменной длины (VLA)
//    test03, test04, test05, test06 
};
#include "main.c"
