#include <stdio.h>
#include <stdlib.h>
#include <alloca.h>

// указатели, адресная арифметика, ссылочные структуры:

//---------------------------------------------------------

void test010( void ) {    // адресная арифметика
   short int sa[] = { 0, 1, 2, 3, 4, 5, 6 };
   void *pv = (void*)&sa[ 0 ];
   int *pi = pv;
   long long *pl = pv;
   float *pf = pv;
   double *pd = pv;
   char *pc = pv;
   pi++, pl++, pf++, pd++, pc++;
   printf( "%p : %p->%d , %p->%d , %p->%d , %p->%d , %p->%d\n", 
           pv,
           pi, *(short*)pi,
           pl, *(short*)pl,
           pf, *(short*)pf,
           pd, *(short*)pd,
           pc, *(short*)pc );
}

//---------------------------------------------------------

void test011( void ) {    // адресная арифметика
   float mem[] = { -1.2345678e+5, +1.2345678e-5 };
   void *pmem = mem; 
   printf( "%p ->\t%d , %d , %d , %ld , %lu ,\n"
           "\t\t%e , %e , %d, '%c'\n",
           pmem,
           *((int*)pmem), 
           *((unsigned int*)pmem), 
           *((short*)pmem), 
           *((long*)pmem), 
           *((unsigned long*)pmem),
           *((float*)pmem),
           *((double*)pmem),
           (int)*((char*)pmem),
           *((char*)pmem)
         );
}

//---------------------------------------------------------

#define SIZE 7

typedef struct node_single {
   struct node_single *next;
   int data;  // данные узла
} node_single_t;

node_single_t* single_add_after( node_single_t *new, node_single_t *node ) {
   new->next = node->next;
   node->next = new;
   return new;
}

void test020( void ) {
   struct node_single nd = { NULL, 1 }, *head = &nd, *pc = head;
   int i;
   for( i = 0; i < SIZE; i ++ )
      ( pc = single_add_after( (node_single_t*)alloca( sizeof( node_single_t) ), pc )
      )->data = i + 2;
   pc = head;
   do {                        // проход по списку
      printf( "%d, ", pc->data );
      pc = pc->next;
   } while( pc != NULL );
   printf( "\n" ); 
}

//---------------------------------------------------------
// from kernel: "/lib/modules/.../source/include/linux/list.h"
typedef struct list_head {
   struct list_head *next, *prev;
} list_head_t;

void INIT_LIST_HEAD( list_head_t *list ) {
   list->next = list;
   list->prev = list;
}

list_head_t* list_add_after( list_head_t *new, list_head_t *node ) {
   node->next->prev = new;
   new->next = node->next;
   new->prev = node;
   node->next = new;
   return new;
}

struct node {
   list_head_t link;
   int data;  // данные узла
};

void test021( void ) {
   struct node nd = { {}, 1 }, *head = &nd;
   INIT_LIST_HEAD( (list_head_t*)head );
   int i;
   list_head_t *pc = (list_head_t*)head;
   for( i = 0; i < SIZE; i ++ )
      ((struct node*)( pc = list_add_after(
                               (list_head_t*)alloca( sizeof( list_head_t ) ), pc )
                     ))->data = i + 2;
   pc = (list_head_t*)head;
   do {                        // обход кольцевого списка вперёд
      printf( "%d, ", ((struct node*)pc)->data );
      pc = pc->next;
   } while( pc != (list_head_t*)head );
   pc = pc->prev;
   do {                        // обход кольцевого списка назад
      printf( "%d, ", ((struct node*)(pc->prev))->data );
      pc = pc->prev;
   } while( pc != (list_head_t*)head );
   printf( "\n" ); 
}

//---------------------------------------------------------

void new_node( struct node_single **pp ) {
   static int key = 0;
   struct node_single *p = malloc( sizeof( node_single_t) );
   p->next = NULL;
   p->data = ++key;
   *pp = p;
}

void destroy( struct node_single *p ) {
   if( p->next ) destroy( p->next );
   free( p );
}

void test030( void ) {
   struct node_single *head = NULL;
   int i;
   for( i = 0; i < SIZE; i ++ ) {   // построение списка
      struct node_single *tail = head;
      new_node( &head );
      head->next = tail;
   }
   struct node_single *pc = head;
   do {                             // проход по списку
      printf( "%d, ", pc->data );
      pc = pc->next;
   } while( pc != NULL );
   printf( "\n" ); 
   destroy( head );                 // уничтожение списка
}

//---------------------------------------------------------

void ( *tests[] )( void ) = {          // последовательность тестов
        test010,                       // адресная арифметика
        test011,                       // тип указателя
        test020,                       // 1-но связный список
        test021,                       // 2-х связный кольцевой список
        test030,                       // передача указателя-параметра по адресу
};
#include "main.c"


