#include <stdio.h>
#include <stdlib.h>

// решето Эратосфена 
// http://ru.wikipedia.org/wiki/%D0%E5%F8%E5%F2%EE_%DD%F0%E0%F2%EE%F1%F4%E5%ED%E0
// битовое решение

#define TYPE unsigned long long
//#define TYPE char
static const uint size = sizeof( TYPE ) * 8;

void set( TYPE arr[], ulong pos, int val ) {
   ulong el = pos / size;
   TYPE  sh = (TYPE)1 << ( pos % size );
   if( 0 == val ) 
      arr[ el + 1 ] &= ~sh;
   else
      arr[ el + 1 ] |= sh;
}

int get( TYPE arr[], ulong pos ) {
   ulong el = pos / size;
   TYPE  sh = (TYPE)1 << ( pos % size );
   return 0 == ( arr[ el + 1 ] & sh ) ? 0 : 1;
}

void eratos( TYPE *arr, ulong size ) {
   ulong i, j;
   for( i = 2; i * i <= size; i += i > 2 ? 2 : 1 ) // цикл от первого простого числа "2"
      if( 1 == get( arr, i ) ) 
         for( j = i * i; j < size; j += i )        // вычеркивание всех чисел кратных i 
            set( arr, j, 0 );
}

#define INLINE 10

int main( int argc, char **argv ) {
   long n;
   while( 1 ) {
      int i;
      printf( "граничное число: " );
      fflush( stdout );
      i = scanf( "%lu", &n );
      if( i <= 0 || n < 0 ) {
         printf( "\n" );
         break;
      }
      ulong k, j;
      k = n / size + 1;
      TYPE *a = calloc( k, size );
      set( a, 0, 0 );
      set( a, 1, 0 );                          // вычёркиваем "0" и "1"
      for( k = 2; k < n; k++ ) set( a, k, 1 ); // остальные размечаем как простые
      eratos( a, n );
      for( k = 0, j = 0; k < n; k++ )
         j += ( get( a, k ) != 0 ? 1 : 0 );
      printf( "%lu простых чисел:\n", j );
      for( k = 0, j = 0; k < n; k++ )
         if( 1 == get( a, k ) ) {
            j++;
            printf( "%5lu%s", k, ( 0 == j % INLINE ? "\n" : "" ) );
         }
      if( j % INLINE != 0 ) printf( "\n" );
      free( a );
   }
   return 0;
}
