#include <stdio.h>
#include <stdlib.h>

// решето Эратосфена 
// http://ru.wikipedia.org/wiki/%D0%E5%F8%E5%F2%EE_%DD%F0%E0%F2%EE%F1%F4%E5%ED%E0

void eratos1( short *arr, ulong size ) {
   ulong i, j;
   for( i = 2; i < size; i++ )                     // цикл по всему массиву от первого простого числа "2"
      if( 1 == arr[ i ] ) 
         for( j = i + i; j < size; j += i )        // вычеркивание всех чисел кратных i 
           arr[ j ] = 0;
}

void eratos2( short *arr, ulong size ) {           // оптимизированный вариант
   ulong i, j;
   for( i = 2; i * i <= size; i += i > 2 ? 2 : 1 ) // цикл по всему массиву от первого простого числа "2"
      if( 1 == arr[ i ] ) 
         for( j = i * i; j < size; j += i )        // вычеркивание всех чисел кратных i 
           arr[ j ] = 0;
}

//#define eratos eratos1
#define eratos eratos2
#define INLINE 10

int main( int argc, char **argv ) {
   long n;
   while( 1 ) {
      int i;
      printf( "граничное число: " );
      fflush( stdout );
      i = scanf( "%lu", &n );
      if( i <= 0 || n < 0 ) {
         printf( "\n" );
         break;
      }
      ulong k, j;
      short *a = calloc( n + 1, sizeof( short ) );
      a[ 0 ] = a[ 1 ] = 0;                   // вычёркиваем "0" и "1"
      for( k = 2; k < n; k++ ) a[ k ] = 1;   // остальные размечаем как простые
      eratos( a, n );
      for( k = 0, j = 0; k < n; k++ )
         j += ( a[ k ] != 0 ? 1 : 0 );
      printf( "%lu простых чисел:\n", j );
      for( k = 0, j = 0; k < n; k++ )
         if( 1 == a[ k ] ) {
            j++;
            printf( "%5lu%s", k, ( 0 == j % INLINE ? "\n" : "" ) );
         }
      if( j % INLINE != 0 ) printf( "\n" );
      free( a );
   }
   return 0;
}
