#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LINKS 3
struct node {           // отдельный узел графа
   int num;
   struct node *ch[ LINKS ];
} graf[] = {            // направленный граф - пирамида
   { 1, { &graf[ 1 ], &graf[ 2 ], &graf[ 3 ] } },
   { 2, { &graf[ 0 ], &graf[ 2 ], &graf[ 3 ] } },
   { 3, { &graf[ 0 ], &graf[ 1 ], &graf[ 3 ] } }, 
   { 4, { &graf[ 0 ], &graf[ 1 ], &graf[ 2 ] } }, 
};
int size = sizeof( graf ) / sizeof( graf[ 0 ] );

struct list {           // список пройденных узлов
   struct node *ptr;
   struct list *next;
};

int length( struct list *plist ) {
   struct list *p = plist;
   int n = 1;
   while( ( p = p->next ) != NULL ) n++;
   return n;
}

int into( struct list *plist, struct node *ptr ) {
   struct list *p = plist;
   do {
      if( p->ptr == ptr ) return 1;
   } while( ( p = p->next ) != NULL );
   return 0;
}

void next( struct list *prev ) {
   int i, L = length( prev );
   if( L >= size ) return;  // страховка завершения
   for( i = 0; i < L - 2; i++ ) printf( "     " );
   if( i < L - 1 ) printf( "+--->" );
   printf( "%d\n", prev->ptr->num );
   struct node *curr = prev->ptr;
   for( i = 0; i < LINKS; i++ ) {
      if( NULL == curr->ch[ i ] || into( prev, curr->ch[ i ] ) ) continue;
      struct list nxt = { curr->ch[ i ], prev };
      next( &nxt );
   }
}

int main( int argc, char **argv, char **envp ) {
   int n, m;
   char msg[ 100 ] = "начальный узел [ ";
   for( m = 0; m < size; m++ )
      sprintf( msg + strlen( msg ), " %d%s ",
               ( graf + m )->num, ( m != size - 1 ? "," : " ]:" ) );
   while( 1 ) {
      printf( "%s", msg );
      fflush( stdout );
      m = scanf( "%d", &n );
      if( m <= 0 ) {
         if( m < 0 ) printf( "\n" );
         break;
      }
      for( m = 0; m < size; m++ )
         if( ( graf + m )->num == n ) break;
      if( m == size ) printf( "нет такого узла!\n" );
      else {
         struct list arg = { graf + m, NULL };
         next( &arg );
      }
   }
   return 0;
}
